<?php

/*********************************************************
 * Name: login.php
 * Author: Dave Conley
 * Contact: realworld@blazefans.com
 * Description: Functions for managing user logins
 * Version: 4.00
 * Last edited: 9th March, 2004
 *********************************************************/

$loader = new login();

class login
{
	var $html;
	var $output;
	
	function login()
	{
	    global $IN, $OUTPUT;
		
		$this->html = $OUTPUT->load_template("skin_login");
		switch($IN["ACT"])
		{
			case 'logout':
			$this->logout();
			break;

			case 'dologin':
			$this->dologin();
			break;

			default:
			$this->showlogin();
			break;
		}
		$OUTPUT->add_output($this->output);
		
	}
	
	function showlogin()
	{
		global $std, $IN, $CONFIG;
		
        $std->updateNav(" > ".GETLANG("nav_login"), 0);
		$data = array();
		if ( $IN["referer"] )
			$data["referer"] = $IN["referer"];
		else
			$data["referer"] = "index.php";
	    $data["posturl"] = "index.php?ACT=dologin";
		
	    $this->output .= $this->html->login_form($data);

	}

	function dologin()
	{
	    global $CONFIG, $IN, $std;

        $std->updateNav(" > ".GETLANG("nav_login"), 0);
        if ( $CONFIG["usertype"] == "vb3" )
        {
            foreach( $IN as $t=>$u )
            {
                $IN[$t] = $std->undoHTMLChars($u);
            }
        }
	    $liuser = new user();
		$liuser->initialise();
	    $liuser->do_login();
	    if ($liuser->valid)
	    {
		    $std->rw_setcookie("rwd_userid", $liuser->userid, $IN["remember"]);
		    $std->rw_setcookie("rwd_password", $liuser->password, $IN["remember"]);
		    $std->rw_setcookie("rwd_username", $liuser->username, $IN["remember"]);
		    $std->rw_setcookie("rwd_userlevel", $liuser->userlevel, $IN["remember"]);

			$data['referurl'] = $IN["referurl"];
			$data['message'] = GETLANG("login_ok");
			$this->output .= $this->html->login_redirect($data);
	    }
		else
		{
			$std->error("Login failed");
		}
	}

	function logout()
	{
	    global $std, $IN, $CONFIG;
	    
	    $std->rw_setcookie("rwd_userid", "0");
	    $std->rw_setcookie("rwd_password", "0");
	    $std->rw_setcookie("rwd_username", "0");
	    $std->rw_setcookie("rwd_userlevel", "0");

        $std->updateNav(" > ".GETLANG("nav_logout"), 0);

		if ( $IN["referer"] )
			$data['referurl'] = $IN["referer"];
		else
			$data['referurl'] = "index.php";

		$data['message'] = GETLANG("logout_ok");
		$this->output .= $this->html->login_redirect($data);
	}
}
?>